Open CASCADE Technology: BRep_Tool Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Static Public Member Functions
BRep_Tool Class Reference

Provides class methods to access to the geometry of BRep shapes. More...

`#include <BRep_Tool.hxx>`

## Static Public Member Functions
static Standard_Boolean | IsClosed (const TopoDS_Shape &S)
| If S is Shell, returns True if it has no free boundaries (edges). If S is Wire, returns True if it has no free ends (vertices). (Internal and External sub-shepes are ignored in these checks) If S is Edge, returns True if its vertices are the same. For other shape types returns S.Closed(). More...
static const Handle< Geom_Surface > & | Surface (const TopoDS_Face &F, TopLoc_Location &L)
| Returns the geometric surface of the face. Returns in <L> the location for the surface. More...
static Handle< Geom_Surface > | Surface (const TopoDS_Face &F)
| Returns the geometric surface of the face. It can be a copy if there is a Location. More...
static const Handle< Poly_Triangulation > & | Triangulation (const TopoDS_Face &F, TopLoc_Location &L)
| Returns the Triangulation of the face. It is a null handle if there is no triangulation. More...
static Standard_Real | Tolerance (const TopoDS_Face &F)
| Returns the tolerance of the face. More...
static Standard_Boolean | NaturalRestriction (const TopoDS_Face &F)
| Returns the NaturalRestriction flag of the face. More...
static Standard_Boolean | IsGeometric (const TopoDS_Edge &E)
| Returns True if <E> is a 3d curve or a curve on surface. More...
static const Handle< Geom_Curve > & | Curve (const TopoDS_Edge &E, TopLoc_Location &L, Standard_Real &First, Standard_Real &Last)
| Returns the 3D curve of the edge. May be a Null handle. Returns in <L> the location for the curve. In <First> and <Last> the parameter range. More...
static Handle< Geom_Curve > | Curve (const TopoDS_Edge &E, Standard_Real &First, Standard_Real &Last)
| Returns the 3D curve of the edge. May be a Null handle. In <First> and <Last> the parameter range. It can be a copy if there is a Location. More...
static const Handle< Poly_Polygon3D > & | Polygon3D (const TopoDS_Edge &E, TopLoc_Location &L)
| Returns the 3D polygon of the edge. May be a Null handle. Returns in <L> the location for the polygon. More...
static Handle< Geom2d_Curve > | CurveOnSurface (const TopoDS_Edge &E, const TopoDS_Face &F, Standard_Real &First, Standard_Real &Last)
| Returns the curve associated to the edge in the parametric space of the face. Returns a NULL handle if this curve does not exist. Returns in <First> and <Last> the parameter range. More...
static Handle< Geom2d_Curve > | CurveOnSurface (const TopoDS_Edge &E, const Handle< Geom_Surface > &S, const TopLoc_Location &L, Standard_Real &First, Standard_Real &Last)
| Returns the curve associated to the edge in the parametric space of the surface. Returns a NULL handle if this curve does not exist. Returns in <First> and <Last> the parameter range. More...
static void | CurveOnSurface (const TopoDS_Edge &E, Handle< Geom2d_Curve > &C, Handle< Geom_Surface > &S, TopLoc_Location &L, Standard_Real &First, Standard_Real &Last)
| Returns in `, <S>, <L> a 2d curve, a surface and a location for the edge <E>. `and <S> are null if the edge has no curve on surface. Returns in <First> and <Last> the parameter range.`` More...
static void | CurveOnSurface (const TopoDS_Edge &E, Handle< Geom2d_Curve > &C, Handle< Geom_Surface > &S, TopLoc_Location &L, Standard_Real &First, Standard_Real &Last, const Standard_Integer Index)
| Returns in `, <S>, <L> the 2d curve, the surface and the location for the edge <E> of rank <Index>. `and <S> are null if the index is out of range. Returns in <First> and <Last> the parameter range.`` More...
static Handle< Poly_Polygon2D > | PolygonOnSurface (const TopoDS_Edge &E, const TopoDS_Face &F)
| Returns the polygon associated to the edge in the parametric space of the face. Returns a NULL handle if this polygon does not exist. More...
static Handle< Poly_Polygon2D > | PolygonOnSurface (const TopoDS_Edge &E, const Handle< Geom_Surface > &S, const TopLoc_Location &L)
| Returns the polygon associated to the edge in the parametric space of the surface. Returns a NULL handle if this polygon does not exist. More...
static void | PolygonOnSurface (const TopoDS_Edge &E, Handle< Poly_Polygon2D > &C, Handle< Geom_Surface > &S, TopLoc_Location &L)
| Returns in `, <S>, <L> a 2d curve, a surface and a location for the edge <E>. `and <S> are null if the edge has no polygon on surface.`` More...
static void | PolygonOnSurface (const TopoDS_Edge &E, Handle< Poly_Polygon2D > &C, Handle< Geom_Surface > &S, TopLoc_Location &L, const Standard_Integer Index)
| Returns in `, <S>, <L> the 2d curve, the surface and the location for the edge <E> of rank <Index>. `and <S> are null if the index is out of range.`` More...
static const Handle< Poly_PolygonOnTriangulation > & | PolygonOnTriangulation (const TopoDS_Edge &E, const Handle< Poly_Triangulation > &T, const TopLoc_Location &L)
| Returns the polygon associated to the edge in the parametric space of the face. Returns a NULL handle if this polygon does not exist. More...
static void | PolygonOnTriangulation (const TopoDS_Edge &E, Handle< Poly_PolygonOnTriangulation > &P, Handle< Poly_Triangulation > &T, TopLoc_Location &L)
| Returns in. More...
static void | PolygonOnTriangulation (const TopoDS_Edge &E, Handle< Poly_PolygonOnTriangulation > &P, Handle< Poly_Triangulation > &T, TopLoc_Location &L, const Standard_Integer Index)
| Returns in. More...
static Standard_Boolean | IsClosed (const TopoDS_Edge &E, const TopoDS_Face &F)
| Returns True if <E> has two PCurves in the parametric space of <F>. i.e. <F> is on a closed surface and <E> is on the closing curve. More...
static Standard_Boolean | IsClosed (const TopoDS_Edge &E, const Handle< Geom_Surface > &S, const TopLoc_Location &L)
| Returns True if <E> has two PCurves in the parametric space of <S>. i.e. <S> is a closed surface and <E> is on the closing curve. More...
static Standard_Boolean | IsClosed (const TopoDS_Edge &E, const Handle< Poly_Triangulation > &T, const TopLoc_Location &L)
| Returns True if <E> has two arrays of indices in the triangulation <T>. More...
static Standard_Real | Tolerance (const TopoDS_Edge &E)
| Returns the tolerance for <E>. More...
static Standard_Boolean | SameParameter (const TopoDS_Edge &E)
| Returns the SameParameter flag for the edge. More...
static Standard_Boolean | SameRange (const TopoDS_Edge &E)
| Returns the SameRange flag for the edge. More...
static Standard_Boolean | Degenerated (const TopoDS_Edge &E)
| Returns True if the edge is degenerated. More...
static void | Range (const TopoDS_Edge &E, Standard_Real &First, Standard_Real &Last)
| Gets the range of the 3d curve. More...
static void | Range (const TopoDS_Edge &E, const Handle< Geom_Surface > &S, const TopLoc_Location &L, Standard_Real &First, Standard_Real &Last)
| Gets the range of the edge on the pcurve on the surface. More...
static void | Range (const TopoDS_Edge &E, const TopoDS_Face &F, Standard_Real &First, Standard_Real &Last)
| Gets the range of the edge on the pcurve on the face. More...
static void | UVPoints (const TopoDS_Edge &E, const Handle< Geom_Surface > &S, const TopLoc_Location &L, gp_Pnt2d &PFirst, gp_Pnt2d &PLast)
| Gets the UV locations of the extremities of the edge. More...
static void | UVPoints (const TopoDS_Edge &E, const TopoDS_Face &F, gp_Pnt2d &PFirst, gp_Pnt2d &PLast)
| Gets the UV locations of the extremities of the edge. More...
static void | SetUVPoints (const TopoDS_Edge &E, const Handle< Geom_Surface > &S, const TopLoc_Location &L, const gp_Pnt2d &PFirst, const gp_Pnt2d &PLast)
| Sets the UV locations of the extremities of the edge. More...
static void | SetUVPoints (const TopoDS_Edge &E, const TopoDS_Face &F, const gp_Pnt2d &PFirst, const gp_Pnt2d &PLast)
| Sets the UV locations of the extremities of the edge. More...
static Standard_Boolean | HasContinuity (const TopoDS_Edge &E, const TopoDS_Face &F1, const TopoDS_Face &F2)
| Returns True if the edge is on the surfaces of the two faces. More...
static GeomAbs_Shape | Continuity (const TopoDS_Edge &E, const TopoDS_Face &F1, const TopoDS_Face &F2)
| Returns the continuity. More...
static Standard_Boolean | HasContinuity (const TopoDS_Edge &E, const Handle< Geom_Surface > &S1, const Handle< Geom_Surface > &S2, const TopLoc_Location &L1, const TopLoc_Location &L2)
| Returns True if the edge is on the surfaces. More...
static GeomAbs_Shape | Continuity (const TopoDS_Edge &E, const Handle< Geom_Surface > &S1, const Handle< Geom_Surface > &S2, const TopLoc_Location &L1, const TopLoc_Location &L2)
| Returns the continuity. More...
static Standard_Boolean | HasContinuity (const TopoDS_Edge &E)
| Returns True if the edge has regularity on some two surfaces. More...
static gp_Pnt | Pnt (const TopoDS_Vertex &V)
| Returns the 3d point. More...
static Standard_Real | Tolerance (const TopoDS_Vertex &V)
| Returns the tolerance. More...
static Standard_Real | Parameter (const TopoDS_Vertex &V, const TopoDS_Edge &E)
| Returns the parameter of <V> on <E>. More...
static Standard_Real | Parameter (const TopoDS_Vertex &V, const TopoDS_Edge &E, const TopoDS_Face &F)
| Returns the parameters of the vertex on the pcurve of the edge on the face. More...
static Standard_Real | Parameter (const TopoDS_Vertex &V, const TopoDS_Edge &E, const Handle< Geom_Surface > &S, const TopLoc_Location &L)
| Returns the parameters of the vertex on the pcurve of the edge on the surface. More...
static gp_Pnt2d | Parameters (const TopoDS_Vertex &V, const TopoDS_Face &F)
| Returns the parameters of the vertex on the face. More...

## Detailed Description

Provides class methods to access to the geometry of BRep shapes.

## Member Function Documentation

static GeomAbs_Shape BRep_Tool::Continuity | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F1,
|  | const TopoDS_Face & | F2
| ) |  |
| static

Returns the continuity.

static GeomAbs_Shape BRep_Tool::Continuity | ( | const TopoDS_Edge & | E,
|  | const Handle< Geom_Surface > & | S1,
|  | const Handle< Geom_Surface > & | S2,
|  | const TopLoc_Location & | L1,
|  | const TopLoc_Location & | L2
| ) |  |
| static

Returns the continuity.

static const Handle< Geom_Curve >& BRep_Tool::Curve | ( | const TopoDS_Edge & | E,
|  | TopLoc_Location & | L,
|  | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  |
| static

Returns the 3D curve of the edge. May be a Null handle. Returns in <L> the location for the curve. In <First> and <Last> the parameter range.

static Handle< Geom_Curve > BRep_Tool::Curve | ( | const TopoDS_Edge & | E,
|  | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  |
| static

Returns the 3D curve of the edge. May be a Null handle. In <First> and <Last> the parameter range. It can be a copy if there is a Location.

static Handle< Geom2d_Curve > BRep_Tool::CurveOnSurface | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F,
|  | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  |
| static

Returns the curve associated to the edge in the parametric space of the face. Returns a NULL handle if this curve does not exist. Returns in <First> and <Last> the parameter range.

static Handle< Geom2d_Curve > BRep_Tool::CurveOnSurface | ( | const TopoDS_Edge & | E,
|  | const Handle< Geom_Surface > & | S,
|  | const TopLoc_Location & | L,
|  | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  |
| static

Returns the curve associated to the edge in the parametric space of the surface. Returns a NULL handle if this curve does not exist. Returns in <First> and <Last> the parameter range.

static void BRep_Tool::CurveOnSurface | ( | const TopoDS_Edge & | E,
|  | Handle< Geom2d_Curve > & | C,
|  | Handle< Geom_Surface > & | S,
|  | TopLoc_Location & | L,
|  | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  |
| static

Returns in `, <S>, <L> a 2d curve, a surface and a location for the edge <E>. `and <S> are null if the edge has no curve on surface. Returns in <First> and <Last> the parameter range.``

static void BRep_Tool::CurveOnSurface | ( | const TopoDS_Edge & | E,
|  | Handle< Geom2d_Curve > & | C,
|  | Handle< Geom_Surface > & | S,
|  | TopLoc_Location & | L,
|  | Standard_Real & | First,
|  | Standard_Real & | Last,
|  | const Standard_Integer | Index
| ) |  |
| static

Returns in `, <S>, <L> the 2d curve, the surface and the location for the edge <E> of rank <Index>. `and <S> are null if the index is out of range. Returns in <First> and <Last> the parameter range.``

static Standard_Boolean BRep_Tool::Degenerated | ( | const TopoDS_Edge & | E | ) |
| static

Returns True if the edge is degenerated.

static Standard_Boolean BRep_Tool::HasContinuity | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F1,
|  | const TopoDS_Face & | F2
| ) |  |
| static

Returns True if the edge is on the surfaces of the two faces.

static Standard_Boolean BRep_Tool::HasContinuity | ( | const TopoDS_Edge & | E,
|  | const Handle< Geom_Surface > & | S1,
|  | const Handle< Geom_Surface > & | S2,
|  | const TopLoc_Location & | L1,
|  | const TopLoc_Location & | L2
| ) |  |
| static

Returns True if the edge is on the surfaces.

static Standard_Boolean BRep_Tool::HasContinuity | ( | const TopoDS_Edge & | E | ) |
| static

Returns True if the edge has regularity on some two surfaces.

static Standard_Boolean BRep_Tool::IsClosed | ( | const TopoDS_Shape & | S | ) |
| static

If S is Shell, returns True if it has no free boundaries (edges). If S is Wire, returns True if it has no free ends (vertices). (Internal and External sub-shepes are ignored in these checks) If S is Edge, returns True if its vertices are the same. For other shape types returns S.Closed().

static Standard_Boolean BRep_Tool::IsClosed | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F
| ) |  |
| static

Returns True if <E> has two PCurves in the parametric space of <F>. i.e. <F> is on a closed surface and <E> is on the closing curve.

static Standard_Boolean BRep_Tool::IsClosed | ( | const TopoDS_Edge & | E,
|  | const Handle< Geom_Surface > & | S,
|  | const TopLoc_Location & | L
| ) |  |
| static

Returns True if <E> has two PCurves in the parametric space of <S>. i.e. <S> is a closed surface and <E> is on the closing curve.

static Standard_Boolean BRep_Tool::IsClosed | ( | const TopoDS_Edge & | E,
|  | const Handle< Poly_Triangulation > & | T,
|  | const TopLoc_Location & | L
| ) |  |
| static

Returns True if <E> has two arrays of indices in the triangulation <T>.

static Standard_Boolean BRep_Tool::IsGeometric | ( | const TopoDS_Edge & | E | ) |
| static

Returns True if <E> is a 3d curve or a curve on surface.

static Standard_Boolean BRep_Tool::NaturalRestriction | ( | const TopoDS_Face & | F | ) |
| static

Returns the NaturalRestriction flag of the face.

static Standard_Real BRep_Tool::Parameter | ( | const TopoDS_Vertex & | V,
|  | const TopoDS_Edge & | E
| ) |  |
| static

Returns the parameter of <V> on <E>.

static Standard_Real BRep_Tool::Parameter | ( | const TopoDS_Vertex & | V,
|  | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F
| ) |  |
| static

Returns the parameters of the vertex on the pcurve of the edge on the face.

static Standard_Real BRep_Tool::Parameter | ( | const TopoDS_Vertex & | V,
|  | const TopoDS_Edge & | E,
|  | const Handle< Geom_Surface > & | S,
|  | const TopLoc_Location & | L
| ) |  |
| static

Returns the parameters of the vertex on the pcurve of the edge on the surface.

static gp_Pnt2d BRep_Tool::Parameters | ( | const TopoDS_Vertex & | V,
|  | const TopoDS_Face & | F
| ) |  |
| static

Returns the parameters of the vertex on the face.

static gp_Pnt BRep_Tool::Pnt | ( | const TopoDS_Vertex & | V | ) |
| static

Returns the 3d point.

static const Handle< Poly_Polygon3D >& BRep_Tool::Polygon3D | ( | const TopoDS_Edge & | E,
|  | TopLoc_Location & | L
| ) |  |
| static

Returns the 3D polygon of the edge. May be a Null handle. Returns in <L> the location for the polygon.

static Handle< Poly_Polygon2D > BRep_Tool::PolygonOnSurface | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F
| ) |  |
| static

Returns the polygon associated to the edge in the parametric space of the face. Returns a NULL handle if this polygon does not exist.

static Handle< Poly_Polygon2D > BRep_Tool::PolygonOnSurface | ( | const TopoDS_Edge & | E,
|  | const Handle< Geom_Surface > & | S,
|  | const TopLoc_Location & | L
| ) |  |
| static

Returns the polygon associated to the edge in the parametric space of the surface. Returns a NULL handle if this polygon does not exist.

static void BRep_Tool::PolygonOnSurface | ( | const TopoDS_Edge & | E,
|  | Handle< Poly_Polygon2D > & | C,
|  | Handle< Geom_Surface > & | S,
|  | TopLoc_Location & | L
| ) |  |
| static

Returns in `, <S>, <L> a 2d curve, a surface and a location for the edge <E>. `and <S> are null if the edge has no polygon on surface.``

static void BRep_Tool::PolygonOnSurface | ( | const TopoDS_Edge & | E,
|  | Handle< Poly_Polygon2D > & | C,
|  | Handle< Geom_Surface > & | S,
|  | TopLoc_Location & | L,
|  | const Standard_Integer | Index
| ) |  |
| static

Returns in `, <S>, <L> the 2d curve, the surface and the location for the edge <E> of rank <Index>. `and <S> are null if the index is out of range.``

static const Handle< Poly_PolygonOnTriangulation >& BRep_Tool::PolygonOnTriangulation | ( | const TopoDS_Edge & | E,
|  | const Handle< Poly_Triangulation > & | T,
|  | const TopLoc_Location & | L
| ) |  |
| static

Returns the polygon associated to the edge in the parametric space of the face. Returns a NULL handle if this polygon does not exist.

static void BRep_Tool::PolygonOnTriangulation | ( | const TopoDS_Edge & | E,
|  | Handle< Poly_PolygonOnTriangulation > & | P,
|  | Handle< Poly_Triangulation > & | T,
|  | TopLoc_Location & | L
| ) |  |
| static

Returns in.

, <T>, <L> a polygon on triangulation, a triangulation and a location for the edge <E>.

and <T> are null if the edge has no polygon on triangulation.

static void BRep_Tool::PolygonOnTriangulation | ( | const TopoDS_Edge & | E,
|  | Handle< Poly_PolygonOnTriangulation > & | P,
|  | Handle< Poly_Triangulation > & | T,
|  | TopLoc_Location & | L,
|  | const Standard_Integer | Index
| ) |  |
| static

Returns in.

, <T>, <L> a polygon on triangulation, a triangulation and a location for the edge <E> for the range index. `and <S> are null if the edge has no polygon on triangulation.`

static void BRep_Tool::Range | ( | const TopoDS_Edge & | E,
|  | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  |
| static

Gets the range of the 3d curve.

static void BRep_Tool::Range | ( | const TopoDS_Edge & | E,
|  | const Handle< Geom_Surface > & | S,
|  | const TopLoc_Location & | L,
|  | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  |
| static

Gets the range of the edge on the pcurve on the surface.

static void BRep_Tool::Range | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F,
|  | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  |
| static

Gets the range of the edge on the pcurve on the face.

static Standard_Boolean BRep_Tool::SameParameter | ( | const TopoDS_Edge & | E | ) |
| static

Returns the SameParameter flag for the edge.

static Standard_Boolean BRep_Tool::SameRange | ( | const TopoDS_Edge & | E | ) |
| static

Returns the SameRange flag for the edge.

static void BRep_Tool::SetUVPoints | ( | const TopoDS_Edge & | E,
|  | const Handle< Geom_Surface > & | S,
|  | const TopLoc_Location & | L,
|  | const gp_Pnt2d & | PFirst,
|  | const gp_Pnt2d & | PLast
| ) |  |
| static

Sets the UV locations of the extremities of the edge.

static void BRep_Tool::SetUVPoints | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F,
|  | const gp_Pnt2d & | PFirst,
|  | const gp_Pnt2d & | PLast
| ) |  |
| static

Sets the UV locations of the extremities of the edge.

static const Handle< Geom_Surface >& BRep_Tool::Surface | ( | const TopoDS_Face & | F,
|  | TopLoc_Location & | L
| ) |  |
| static

Returns the geometric surface of the face. Returns in <L> the location for the surface.

static Handle< Geom_Surface > BRep_Tool::Surface | ( | const TopoDS_Face & | F | ) |
| static

Returns the geometric surface of the face. It can be a copy if there is a Location.

static Standard_Real BRep_Tool::Tolerance | ( | const TopoDS_Face & | F | ) |
| static

Returns the tolerance of the face.

static Standard_Real BRep_Tool::Tolerance | ( | const TopoDS_Edge & | E | ) |
| static

Returns the tolerance for <E>.

static Standard_Real BRep_Tool::Tolerance | ( | const TopoDS_Vertex & | V | ) |
| static

Returns the tolerance.

static const Handle< Poly_Triangulation >& BRep_Tool::Triangulation | ( | const TopoDS_Face & | F,
|  | TopLoc_Location & | L
| ) |  |
| static

Returns the Triangulation of the face. It is a null handle if there is no triangulation.

static void BRep_Tool::UVPoints | ( | const TopoDS_Edge & | E,
|  | const Handle< Geom_Surface > & | S,
|  | const TopLoc_Location & | L,
|  | gp_Pnt2d & | PFirst,
|  | gp_Pnt2d & | PLast
| ) |  |
| static

Gets the UV locations of the extremities of the edge.

static void BRep_Tool::UVPoints | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F,
|  | gp_Pnt2d & | PFirst,
|  | gp_Pnt2d & | PLast
| ) |  |
| static

Gets the UV locations of the extremities of the edge.

The documentation for this class was generated from the following file:

- BRep_Tool.hxx